code	segment
	assume	cs:code,ds:code

BEEP	macro
	push	ax
	mov	ax,0e07h
	int	10h
	pop	ax
	endm

;---------------------------------- resident ----------------------------------
	org	80h
command_line_length	label	byte
	org	81h
command_line	label	byte
	org	100h
start:	jmp	main
	even

int13h:	pushf;
	mov	cs:function,ah
	cmp	ah,2
	jne	go_away1
	
	mov	cs:new_al,al
	mov	cs:new_cx,cx;
	mov	cs:new_dx,dx;

go_away1:
	popf;

	pushf
	db	9ah		; call old_int13h
old_int13h	dw	?,?

	jnc	ex_13h

	pushf
	cmp	cs:function,2
	jne	ex1_13h
	cmp	dl,80h
	jne	ex1_13h
	
	push	ax
	push	cx
	push	dx
	push	di
	push	ds
	push	es

	push	cs
	pop	ds
	push	cs
	pop	es

	mov	al,new_al
	mov	cx,new_cx;
	mov	dx,new_dx;
	mov	di,max_bad_number
	or	di,di
	je	every_bad
	
	cmp	al,old_al
	jne	ex2_13h
	cmp	cx,old_cx
	jne	ex2_13h
	cmp	dx,old_dx
	jne	ex2_13h

every_bad:
	inc	bad_number
	cmp	bad_number,di
	jb	ex3_13h
	
	cld
	mov	bad_flag,1
	mov	di,buffer_counter
	cmp	di,offset end_resident-5
	jae	ex2_13h
	stosb
	mov	ax,cx
	stosw
	mov	ax,dx
	stosw
	mov	buffer_counter,di
	jmp	ex3_13h

ex2_13h:
	mov	bad_number,0
	mov	old_al,al
	mov	old_cx,cx
	mov	old_dx,dx

ex3_13h:
	pop	es
	pop	ds
	pop	di
	pop	dx
	pop	cx
	pop	ax

ex1_13h:
	popf
ex_13h:	retf 2

ex_28h_:
	jmp	ex_28h
	
int28h:	pushf
	cmp	cs:bad_flag,1
	jne	ex_28h_
	cmp	cs:call_flag,1
	je	ex_28h_
	cmp	cs:disk_op_flag,1
	je	ex_28h_

	push	ax
	push	bx
	push	di
	push	es
	les	bx,cs:DOS_flag
	mov	al,es:[bx]
	cmp	al,0
	je	a_28h
	jmp	ex1_28h

a_28h:	mov	si,cs:buffer_counter
	cmp	si,offset buffer
	jne	b_28h
	jmp	ex1_28h

b_28h:	BEEP
	mov	call_flag,1
	push	cx
	push	dx
	push	si
	push	ds
	push	cs
	pop	ds
	
	lea	dx,fspec
	mov	ax,3d02h
	int	21h
	mov	fm,ax
	
	xor	cx,cx
	xor	dx,dx
	mov	bx,fm
	mov	ax,4202h
	int	21h
	
next:	sub	si,2
	mov	bx,[si]		; bh - head
	sub	si,2
	mov	ax,[si]
	dec	al
	mov	bl,al
	and	bl,3fh		; bl - sector
	xchg	al,ah
	mov	cl,6
	shr	ah,cl		; ax - cylinder
	mov	dl,heads_count
	mul	dl		; ax - sides in these cylinders
	add	al,bh
	adc	ah,0		; ax - sides for all
	mov	dx,sectors_per_track
	mul	dx		; dx:ax - sectors without last side
	xor	bh,bh
	add	ax,bx
	adc	dx,0		; dx:ax - sectors for all
	
	dec	si
	mov	buffer_counter,si
	mov	bh,[si]
	xor	bl,bl
	xchg	dl,dh
	xchg	al,ah
	mov	word ptr file_buffer,dx
	mov	word ptr file_buffer[2],ax
;	mov	word ptr file_buffer[4],bx
;	mov	word ptr file_buffer[6],0a0dh
	
	mov	bx,fm
	lea	dx,file_buffer
	mov	cx,4
	mov	ah,40h
	int	21h

	cmp	si,offset buffer
	jne	next
	
	mov	bx,fm
	mov	ah,3eh
	int	21h

	mov	call_flag,0
	mov	bad_flag,0
	pop	ds
	pop	si
	pop	dx
	pop	cx
	
ex1_28h:
	pop	es
	pop	di
	pop	bx
	pop	ax

ex_28h:	popf

	db	0eah		; jmp old_int28h
old_int28h	dw	?,?

int21h:	pushf
	push	ax
	push	cx
	push	si
	push	di
	push	ds
	push	es

	cmp	ah,3dh
	je	go1
	cmp	ah,3eh
	je	go1
	cmp	ah,40h
	je	go1
	cmp	ah,42h
	je	go1
	mov	cs:disk_op_flag,0
	jmp	go_away
	
go1:	mov	cs:disk_op_flag,1
		
go_away:
	cld
	push	cs
	pop	ds
	mov	di,old_int21h
	mov	ax,old_int21h[2]
	mov	es,ax
	lea	si,old_instr
	mov	cx,5
	rep	movsb

	pop	es
	pop	ds
	pop	di
	pop	si
	pop	cx
	pop	ax
	popf

	pushf
	db	9ah		; call old_int21h
old_int21h	dw	?,?

	pushf
	push	ax
	push	cx
	push	di
	push	ds
	push	es
	
	cld
	push	cs
	pop	ds
	mov	di,old_int21h
	mov	ax,old_int21h[2]
	mov	es,ax
	mov	al,0eah
	stosb
	lea	ax,int21h
	stosw
	mov	ax,cs
	stosw

	pop	es
	pop	ds
	pop	di
	pop	cx
	pop	ax
	popf
	sti
	retf 2

;---------------------------------- data --------------------------------------
old_instr	db	5 dup(?)

function	db	?

old_al	db	?
old_cx	dw	?
old_dx	dw	?

new_al	db	?
new_cx	dw	?
new_dx	dw	?

DOS_flag	dd	?
call_flag	db	0
disk_op_flag	db	0
bad_flag	db	0
bad_number	dw	?

sectors_per_track	dw	? ; ᫮ ᥪ஢  ஦
heads_count	db	?	; ᫮ 

max_bad_number	dw	0
fm	dw	?
fspec	db	'c:\errors.dsk',0
file_buffer	db	6 dup(?)

buffer_counter	dw	buffer
buffer	db	1000 dup(?)

end_resident	label	byte

;-------------------------- no resident part ----------------------------------
option_number	db	1
option_addresses	dw	optN
optN	db	'/N$'
	dw	max_bad_number

Read_options	proc	near
	mov	cl,option_number
	xor	ch,ch

to1:	push	cx
	xor	di,di
	xor	dx,dx
	xor	ah,ah
	mov	bl,option_number
	xor	bh,bh
	sub	bx,cx
	shl	bx,1
	mov	bx,[option_addresses+bx]
	lea	si,command_line
	mov	cl,command_line_length
	inc	cl
	xor	ch,ch

to11:	lodsb
	cmp	byte ptr [bx+di],'$'
	je	next_number
	cmp	al,[bx+di]
	je	to2
	cmp	byte ptr [bx+di],'A'
	jb	to21
	cmp	byte ptr [bx+di],'Z'
	ja	to21
	sub	al,'a'-'A'
	cmp	al,[bx+di]
	je	to2
to21:	xor	di,di
	jmp	to3
to2:	inc	di
	jmp	to3

next_number:
	cmp	al,'0'
	jb	to4
	cmp	al,'9'
	ja	to4

	push	ax
	shl	dx,1
	mov	ax,dx
	shl	dx,1
	shl	dx,1
	add	dx,ax
	pop	ax

	sub	al,'0'
	add	dx,ax
	jmp	to3

to4:	mov	di,[bx+di+1]
	mov	[di],dx
	mov	cx,1
to3:	loop	to11

	pop	cx
	loop	to1
	ret
Read_options	endp

read_parameters	proc	near
	mov	ah,2
	mov	dl,80h
	mov	al,1	; sectors_number
	mov	dh,1	; head
	mov	ch,0	; cylinder
	mov	cl,1	; sector
	lea	bx,buffer
	int	13h

	mov	ax,word ptr buffer[18h]
	mov	sectors_per_track,ax
	mov	al,buffer[1ah]
	mov	heads_count,al
	ret
read_parameters	endp

main:	call	Read_options
	call	read_parameters

	lea	dx,fspec
	mov	ax,3d00h
	int	21h
	jnc	exist
	
	mov	ah,3ch
	mov	cx,2
	int	21h
	
exist:	mov	bx,ax
	mov	ah,3eh
	int	21h
	
	mov	ah,34h
	int	21h
	mov	word ptr DOS_flag,bx
	mov	word ptr DOS_flag[2],es
	
	push	cs
	pop	es
	
	cli
	cld
	push    es
	xor	ax,ax
	mov     es,ax
	mov	ax,es:[13h*4]
	mov	old_int13h,ax
	mov	ax,es:[13h*4+2]
	mov	old_int13h[2],ax
	mov	es:[13h*4],offset int13h
	mov	es:[13h*4+2],cs

	mov	ax,es:[28h*4]
	mov	old_int28h,ax
	mov	ax,es:[28h*4+2]
	mov	old_int28h[2],ax
	mov	es:[28h*4],offset int28h
	mov	es:[28h*4+2],cs

	mov	ax,es:[21h*4]
	mov	si,ax
	mov	old_int21h,ax
	mov	ax,es:[21h*4+2]
	mov	old_int21h[2],ax
	pop	es
	
	push	ds
	mov	ds,ax
	lea	di,old_instr
	mov	cx,5
	rep	movsb
	push	ds
	pop	es
	pop	ds

	mov	di,old_int21h
	mov	al,0eah
	stosb
	lea	ax,int21h
	stosw
	mov	ax,cs
	stosw
	push	cs
	pop	es
	sti
	
	lea	dx,end_resident
	int	27h
code    ends
	end	start
